#!/usr/bin/env python
#-*-coding: utf-8-*-
from classes.afi_class import *
import pickle
from datetime import date
import classes.afi_valuation
import classes.names
import decimal
import classes.statistics

#TODO
#pko poprawic spis funduszy
#dodać wartość prowizji

my = []
sold = []

def round(x,r=0):
    return decimal.Decimal(x).quantize(decimal.Decimal(10)**-r,rounding=decimal.ROUND_HALF_UP)

### INPUT ### czy aby na pewno jest potrzebne zaokraglanie przy input??
def get_input_float(info, default = '',r=2):
    while True:
        a = raw_input(info)
        if a == '': a = str(default)
        try:
            a = round(decimal.Decimal(a.replace(',','.')),r)
        except:
            print "To nie jest liczba!!!"
            continue
        return a

def get_input_date(info):
    while True:
        print info
        a = raw_input("Rok [%s] (yyyy):" % date.today().year)
        if a == '': a = date.today().year
        b = raw_input("Miesiac [%s] (mm):" % date.today().month)
        if b == '': b = date.today().month
        c = raw_input("Dzien [%s] (dd):" % date.today().day)
        if c == '': c = date.today().day
        try:
            a = int(a)
            b = int(b)
            c = int(c)
            date(a,b,c)
        except:
            print "To nie jest data!!!"
            continue
        return date(a,b,c)
        
### FILES ### --- 1
def save_file():
    f = open('my.txt', 'w')
    pickle.dump(my, f)
    f.close()
    print 'Zapisano %s rejestrow' % len(my)
    f = open('sold.txt', 'w')
    pickle.dump(sold, f)
    f.close()

def load_file():
    try:
        f = open('my.txt', 'r')
    except IOError:
        print 'nie znaleziono liku my.txt'
        return
    global my
    my = pickle.load(f)
    f.close()
    print 'Wgrano %s rejestrow' % len(my)
    f = open('sold.txt', 'r')
    global sold
    sold = pickle.load(f)
    f.close()

### SHOW ### --- 3
#zastanawiam sie nad zmiana pokazywania cos ala
#Nazwa     | Netto | Buy  | Roznica
#Bla       | ...
def show_registers():
    ch = -1
    while ch == -1:
        print '1. Stary sposób prezentacji danych'
        print '2. Nowy sposób prezentacji danych'
        print '3. Wyjście'
        ch = get_menu_choice(3)

    if ch == 1:
        inv = decimal.Decimal(0)
        now = decimal.Decimal(0)
        for i in my:
            print "_" * 30
            print i
            inv = inv + i.getinvested()
            now = now + i.getvalue()
        
        print 'Razem:\nZainwestowano %s, obecna wartosc %s -- dC %s zl, %s%%' % (round(inv,2), round(now,2), round(now-inv,2),round(decimal.Decimal(-100)+now/inv*decimal.Decimal(100),2))
    elif ch == 2:
        r = {}
        s = []
        for i in my:
            r = classes.statistics.AfiClassExtract(i)
            s.append(classes.statistics.Statistics(r['units'], r['price'], r['buyprice'], r['buydate'], r['date'], r['invested']))
            print '-' * 80
            print 'Fundusz: %s (%s) %s. Typ: %s.' % (i.getfundname(), i.fundnumber, i.getbrandname(), i.type)
            print s[-1]
    
        
def show_subregisters():
    ch = register_choice()
    for i in my[ch]:
        print "_" * 30
        print i
        
### EDIT ###
def edit_register():
    ch = register_choice()
    #       1                2                    3               4               5
    lista = ["Nazwa/Numer","Typ (HIFO,LIFO,FIFO)","Aktualna cena","Aktualna data","Koniec"]
    while True:
        print '-' * 30
        print 'Edytujesz %s' % my[ch].getfundname()
        for i in range(len(lista)):
            print "%s. %s" % (i+1, lista[i])
        men = get_menu_choice(len(lista))
        if men == 1:
            print "Teraz jest %s (%s)" % (my[ch].getfundname(), my[ch].fundnumber)
            b=classes.names.get_brand()
            n=classes.names.get_name(b[0])
            my[ch].setfundnumber(n[0])
        elif men == 2:
            print "Teraz jest %s" % (my[ch].type)
            my[ch].settype(raw_input("Podaj typ (HIFO, FIFO, LIFO):"))
        elif men == 3:
            print "Teraz jest %s" % (my[ch].price)
            my[ch].setprice(get_input_float("Aktualna wycena:",r=4))
        elif men == 4:
            print "Teraz jest %s" % (my[ch].date)
            my[ch].setdate(get_input_date("Aktualna data"))
        elif men == 5: return "ok"
        
def edit_subregister():
    ch = register_choice()
    for i in range(len(my[ch])):
        print "%s. Data zakupu: %s, Cena zakupu: %s" % (i+1, my[ch][i].buydate, my[ch][i].buyprice)
    chs = get_menu_choice(len(my[ch]))
    chs = chs - 1
    #           1                   2               3           4               5
    lista = ["Ilosc jednostek:","Cena zakupu", "Data zakupu","Zainwestowano","Koniec"]
    while True:
        print '-' * 30
        for i in range(len(lista)):
            print "%s. %s" % (i+1, lista[i])
        men = get_menu_choice(len(lista))
        if men == 1:
            print "Teraz jest %s" % (my[ch][chs].units)
            my[ch][chs].setunits(get_input_float("Podaj liczbe jednostek:",r=6))
            if my[ch][chs].setunits == 0:
                print "usuwam podrejestr dz: %s, cz: %s" % (my[ch][chs].buydate, my[ch][chs].buyprice)
                my[ch].pop(chs)
                if my[ch].units <= 0:
                    print "usuwam rejestr %s (bo j.u. jest <=0)" % my[ch].getfundname()
                    my.pop(ch)
                break #bo numeracja sie zmienila
                    
        elif men == 2:
            print "Teraz jest %s" % (my[ch][chs].buyprice)
            my[ch][chs].setbuyprice(get_input_float("Podaj cene zakupu:",r=4))
        elif men == 3:
            print "Teraz jest %s" % (my[ch][chs].buydate)    
            my[ch][chs].setbuydate(get_input_date("Data zakupu:"))
        elif men == 4:
            print "Teraz jest %s" % (my[ch][chs].invested)    
            my[ch][chs].setinvested(get_input_float("Zainwestowano:",r=2))
        elif men == 5: return "ok"
        
### SELL/CONVERT ###
def sell():
    print 'Ktory rejestr sprzedac:'
    ch = register_choice()
    while True:
        u = get_input_float("Liczba jednostek do sprzedania [%s]:"%(my[ch].getunits()),my[ch].getunits(),6)
        if 0 < u <= my[ch].getunits(): break
        print "Zla liczba jednostek (0;%s>" % my[ch].getunits()
    my[ch].setprice(get_input_float('Cena odkupienia [%s]'%(my[ch].price),my[ch].price,4))
    my[ch].setdate(get_input_date('Data odkupienia:'))
    global sold
    sold.append(my[ch].sellsubreg(u))
    print "Sprzedano:"
    for i in sold[-1]:
        print i
    print 'pozostalo %s j.u.' % my[ch].getunits()
    if my[ch].getunits() <= decimal.Decimal(0):
        print "usuwam rejestr %s (bo j.u. jest <=0)" % my[ch].getfundname()
        my.pop(ch)

def convert():
    print 'Ktory rejestr konwertowac:'
    ch = register_choice()
    print 'wybrano %s' % my[ch].getfundname()
    while True:
        u = get_input_float("Liczba jednostek do konwersji[%s]:"%(my[ch].getunits()),my[ch].getunits(),6)
        if 0 < u <= my[ch].getunits(): break
        print "Zla liczba jednostek (0;%s>" % my[ch].getunits()
    my[ch].setprice(get_input_float('Cena po jakiej jest konwersja [%s]'%(my[ch].price),my[ch].price,4))
    my[ch].setdate(get_input_date('Data konwersji:'))
    s = my[ch].sellsubreg(u) #s przechowuje sprzedane podrejestry, teraz nalezy pobrac wartosci
    sinv = decimal.Decimal(0)
    sval = decimal.Decimal(0)
    print "Przekonwertowane zostalo:"
    for i in s:
        print i
        sinv = sinv + i.invested
        sval = sval + i.getvalue()
    sinv = round(sinv,2)
    sval = round(sval,2)
    sval = get_input_float('Kwota konwersji (przeniesiona na nowy fundusz)[%s]:' % (sval), sval,2) 
    print 'Na jaki rejestr konwertowac:'
    fn = my[ch].fundnumber
    b = my[ch].getbrandnumber()
    n = classes.names.get_name(b)
    f = False
    for i in my:
        if i.fundnumber == n[0]:
            print 'Istnieje juz taki rejestr, nastapi zwiekszenie jego j.u.'
            new = SubRegister(invested=sinv)
            new.setbuyprice(get_input_float("Cena zakupu:",r=4))
            new.setunits(get_input_float("Ilosc jednostek uczestnictwa[%s]:"%(round(sval/new.buyprice,6)),round(sval/new.buyprice,6),6))
            new.setbuydate(get_input_date("Data zakupu:"))
            new.setinvested(get_input_float('Inwestycja [%s]'%(sinv) ,sinv,2))
            new.setprice(i.price)
            new.setdate(i.date)
            i.addsubreg(new)
            print 'razem jest %s j.u.' % i.getunits()
            f = True
            break
    if f == False: #czyli nie ma takiego funduszu jeszcze
        print 'Nie istnieje jeszcze takirejestr, nastapi utworzenie jego'
        reg = Register()
        reg.setfundnumber(n[0])
        bn = reg.getbrandnumber()
        
        #allianz=4;skarbiec=5;legg=6;
        if bn == 4 or bn == 5 or bn == 6:
            reg.settype('HIFO')
            print 'nadano typ HIFO'
        #pzu=1;pko=2;union=3;investor=7;bph=8
        elif bn == 8 or bn == 7 or bn == 2 or bn == 3 or bn == 1:
            reg.settype('FIFO')
            print 'nadano typ FIFO'
        else:
            reg.settype(raw_input("Typ (HIFO, FIFO, LIFO):"))
            
        new = SubRegister(invested=sinv)
        new.setbuyprice(get_input_float("Cena zakupu:",r=4))
        new.setunits(get_input_float("Ilosc jednostek uczestnictwa[%s]:"%(round(sval/new.buyprice,6)),round(sval/new.buyprice,6),6))
        new.setbuydate(get_input_date("Data zakupu:"))
        new.setinvested(get_input_float('Inwestycja [%s]'%(sinv) ,sinv,2))
        reg.setprice(new.buyprice)
        reg.setdate(new.buydate)
        new.setprice(reg.price)
        new.setdate(reg.date)
        reg.addsubreg(new)
        my.append(reg)
        print "Dodano rejestr: %s" % reg.getfundname()
        
    if my[ch].getunits() <= decimal.Decimal(0):
        print "usuwam rejestr %s (bo j.u. jest <=0)" % my[ch].getfundname()
        my.pop(ch)

### SETTTINGS ### --- 6
def settings():
    pass
    
### NEW ### --- 7
def new_register():
    #try:
        reg = Register()
        reg.setfundnumber(names.get_name(names.get_brand()[0])[0])
        bn = reg.getbrandnumber()
        #allianz=4;skarbiec=5;legg=6;
        if bn == 4 or bn == 5 or bn == 6:
            reg.settype('HIFO')
            print 'nadano typ HIFO'
        #pzu=1;pko=2;union=3;investor=7;bph=8
        elif bn == 8 or bn == 7 or bn == 2 or bn == 3 or bn == 1:
            reg.settype('FIFO')
            print 'nadano typ FIFO'
        else:
            reg.settype(raw_input("Typ (HIFO, FIFO, LIFO):"))
            
        nsr = new_subregister() #od razu tworzymy podrejestr
        if nsr == "WYSTaPIl BlaD --- new_subregister":
            print "WYSTaPIl BlaD --- new_register -> new_subregister"
            return "WYSTaPIl BlaD --- new_register -> new_subregister"
        reg.addsubreg(nsr)
        reg.setprice(nsr.buyprice)
        reg.setdate(nsr.buydate)
        my.append(reg)
        print "Dodano rejestr: %s" % reg.getfundname()
    #except:
    #    print "WYSTaPIl BlaD --- new_register"
    #    return "WYSTaPIl BlaD --- new_register"
                
def new_subregister():
    #try:
        sr = SubRegister()
        sr.setbuyprice(get_input_float("Cena zakupu:",r=4))
        sr.setunits(get_input_float("Ilosc jednostek uczestnictwa:",r=6))
        sr.setbuydate(get_input_date("Data zakupu:"))
        txt = "Inwestycja [%s]:" % round(sr.buyprice * sr.units,2)
        sr.setinvested(get_input_float(txt ,round(sr.buyprice * sr.units,2),2))
        return sr
    #except:
    #    print "WYSTaPIl BlaD --- new_subregister"
    #    return "WYSTaPIl BlaD --- new_subregister"
        #raise error
    
def new_subregister_alone():
    ch = register_choice()
    nsr = new_subregister()
    if nsr == "WYSTaPIl BlaD --- new_subregister":
        print "WYSTaPIl BlaD --- new_subregister_alone -> new_subregister"
        return "WYSTaPIl BlaD --- new_subregister_alone -> new_subregister"
    #print nsr.date, my[ch].date
    if nsr.buydate > my[ch].date:
        print 'nowsza wycena wporwadzona, ustawiam ja jako obecna'
        my[ch].setprice(nsr.buyprice)
        my[ch].setdate(nsr.buydate)
    nsr.setprice(my[ch].price)
    nsr.setdate(my[ch].date)
    my[ch].addsubreg(nsr)
    print 'razem jest %s j.u.' % my[ch].getunits()
    
### DEL ### --- 8
def delete():
    pass
    
### UPDATE ### --- 9
def update():
    l = len(my)
    n = 1
    fi = classes.afi_valuation.SFILoad()
    sfi = fi.load() #[number,cena(decimal),data wyc]
    print 'Lp.  | Poprzedn.  | Obecna     | Cena p.|Cena akt|Zm. % | Nazwa'
    for i in my:
        #try:
            l_price = i.price
            l_date = i.date
            if i.fundnumber == 0:
                print 'not yet'
                continue
            j=[0]
            for a in sfi:                
                if i.fundnumber == a[0]:
                    j[0]=1
                    j.append(a[1])
                    j.append(a[2])
                    continue

            if len(i.getfundname()) > 18:
                nazwa = i.getfundname()[0:18]
            else:
                nazwa = i.getfundname()
            if j[0]==0:
                j=[0,"Couldn't find","Couldn't find"]
            if (j[2]  == "Couldn't find") or (j[1] == "Couldn't find"):
                print '%s/%s | %s | %s ' % (n,l,nazwa,'couldn find')
                n=n+1
                continue
            else:
                i.setdate(j[2])
                i.setprice(j[1])
            
            print '%s/%s | %s | %s | %s | %s | %s | %s' % (n,l, l_date,i.date, l_price, i.price, round(decimal.Decimal(100)*(i.price - l_price)/l_price,2),nazwa)
            n=n+1
        #except: #trzeba bedzie ograniczyc do AttributeError
        #    i.setprice(1.)
        #    i.setdate(date.today())
        #    print 'Nadano tymczasowe wartosci dla ceny i daty obecnej'

############ RYSOWANIE MENU
def register_choice():
    for i in range(len(my)):
        print "%s. %s (%s)" % (i+1, my[i].getfundname(), my[i].fundnumber)
    ch = get_menu_choice(len(my)+1)
    return ch - 1

def get_menu_choice(number = 8):
    while True:
        a = raw_input("Twoj wybor:")
        try:
            a = int(a)
        except:
            print "To nie jest liczba!!!"
            #print_menu()
            continue
        if 0 < a <= number:
            return a
        else:
            print "Liczba nie jest z przedzialu (1 do %s)" % number
            
def print_menu():
    '''Prints menu
    '''
    print "-" * 30
    #       1          2         3       4               5                 6           7          8         9               10          
    lista = ["Wgraj","Zapisz","Pokaz","Edytuj","Sprzedaj/Konwertuj","Ustawienia","Utworz nowy",'Usun',"Uaktualnij wycene","Wyjdz"]
    for i in range(len(lista)):
        print "%s. %s" % (i+1,lista[i])
    print "-" * 30
    
def print_r_or_sr():
    print "-" * 30
    print "1. Rejestr(y)"
    print "2. Podrejestr(y)"
    
#wgranie pliku w trakcie uruchomienia programu
load_file() 
    
while True: 
    print_menu()
    choice = get_menu_choice(10)

    if choice == 1: ### LOAD
        load_file()
    elif choice == 2: ### SAVE
        raw_input("Save[enter] or ctrl+c(d)")
        if len(my) == 0: raw_input("Nie masz rejestrow, zapisujesz pusty czy jestes ze chcesz?")
        save_file()
    elif choice == 3: #### SHOW
        print_r_or_sr()
        choice = get_menu_choice(2)
        if choice == 1:
            show_registers()
            print "Liczba rejestrow:", len(my)
        elif choice == 2:
            show_subregisters()
    elif choice == 4: ### EDIT
        print_r_or_sr()
        choice = get_menu_choice(2)
        if choice == 1:
            edit_register()
        elif choice == 2:
            edit_subregister()
    elif choice == 5: ### SELL/convert
        print '-' * 30
        print "1. Sprzedac\n2. Konwertowac"
        choice = get_menu_choice(2)
        if choice == 1:
            sell()
        elif choice == 2:
            convert()
    elif choice == 6: ### SETTINGS
        print 'ustawienia niet gotowe'
        settings()
    elif choice == 7: ### NEW
        print_r_or_sr()
        choice = get_menu_choice(2)
        if choice == 1:
            new_register()
        elif choice == 2:
            new_subregister_alone()
    elif choice == 8: ### DEL
        print 'usuwanie niet gotowe'
        delete()
    elif choice == 9: ### UPDATE
        update()
    else:
        odp = raw_input("<Save & exit[enter]> or \n <'n or else' to exit>\n:")
        if odp == '':
            if len(my) == 0: raw_input("Nie masz rejestrow, zapisujesz pusty czy jestes ze chcesz?")
            save_file()
        break
